'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _templateObject = _taggedTemplateLiteral(['\n  border-left: 3px solid ', ';\n  margin-left: -1px;\n  opacity: 0.2;\n'], ['\n  border-left: 3px solid ', ';\n  margin-left: -1px;\n  opacity: 0.2;\n']),
    _templateObject2 = _taggedTemplateLiteral(['\n  border-left: 1px solid ', ';\n  opacity: 0.7;\n'], ['\n  border-left: 1px solid ', ';\n  opacity: 0.7;\n']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _reactRouter = require('react-router');

var _TimestampTooltip = require('../_TimestampTooltip');

var _TimestampTooltip2 = _interopRequireDefault(_TimestampTooltip);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var DeploymentAnnotationWrapper = _styledComponents2.default.div.attrs({
  // Override the parent tooltip
  title: ''
}).withConfig({
  displayName: 'DeploymentAnnotation__DeploymentAnnotationWrapper'
})(['position:absolute;height:100%;']);

var DeploymentAnnotationContainer = _styledComponents2.default.div.attrs({
  style: function style(_ref) {
    var x = _ref.x;
    return { left: x };
  }
}).withConfig({
  displayName: 'DeploymentAnnotation__DeploymentAnnotationContainer'
})(['pointer-events:all;position:absolute;height:100%;']);

var FocusPoint = _styledComponents2.default.span.withConfig({
  displayName: 'DeploymentAnnotation__FocusPoint'
})(['border-radius:', ';border:2.5px solid ', ';background-color:', ';box-sizing:border-box;position:absolute;', ';'], function (props) {
  return props.theme.borderRadius.circle;
}, function (props) {
  return props.theme.colors.blue400;
}, function (props) {
  return props.theme.colors.white;
}, function (props) {
  return '\n    margin-left: -' + props.radius + 'px;\n    margin-top: ' + props.radius + 'px;\n    width: ' + 2 * props.radius + 'px;\n    height: ' + 2 * props.radius + 'px;\n    bottom: -' + (props.onAxis ? props.radius : 0) + 'px;\n  ';
});

var VerticalLine = _styledComponents2.default.div.withConfig({
  displayName: 'DeploymentAnnotation__VerticalLine'
})(['pointer-events:none;position:absolute;height:100%;top:0;']);

var AnnotationShadow = VerticalLine.extend(_templateObject, function (props) {
  return props.theme.colors.white;
});

var AnnotationLine = VerticalLine.extend(_templateObject2, function (props) {
  return props.theme.colors.blue400;
});

var InfoLine = _styledComponents2.default.span.withConfig({
  displayName: 'DeploymentAnnotation__InfoLine'
})(['font-size:', ';margin-top:1px;display:block;white-space:nowrap;text-overflow:ellipsis;overflow:hidden;'], function (props) {
  return props.theme.fontSizes.small;
});

var NoLink = _styledComponents2.default.span.withConfig({
  displayName: 'DeploymentAnnotation__NoLink'
})(['cursor:default;']);

var MaybeLinkable = function MaybeLinkable(_ref2) {
  var linkTo = _ref2.linkTo,
      children = _ref2.children;
  return linkTo ? _react2.default.createElement(
    _reactRouter.Link,
    { to: linkTo },
    children
  ) : _react2.default.createElement(
    NoLink,
    null,
    children
  );
};

var DeploymentAnnotations = function (_React$PureComponent) {
  _inherits(DeploymentAnnotations, _React$PureComponent);

  function DeploymentAnnotations() {
    var _ref3;

    var _temp, _this, _ret;

    _classCallCheck(this, DeploymentAnnotations);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref3 = DeploymentAnnotations.__proto__ || Object.getPrototypeOf(DeploymentAnnotations)).call.apply(_ref3, [this].concat(args))), _this), _this.state = {
      isHovered: false
    }, _this.handleMouseEnter = function () {
      _this.setState({ isHovered: true });
    }, _this.handleMouseLeave = function () {
      _this.setState({ isHovered: false });
    }, _this.handleClick = function () {
      var _this$props = _this.props,
          action = _this$props.action,
          serviceIDs = _this$props.serviceIDs,
          timestamp = _this$props.timestamp;

      _this.props.onClick({ action: action, serviceIDs: serviceIDs, timestamp: timestamp });
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(DeploymentAnnotations, [{
    key: 'render',
    value: function render() {
      return _react2.default.createElement(
        DeploymentAnnotationWrapper,
        null,
        _react2.default.createElement(
          DeploymentAnnotationContainer,
          { x: this.props.x },
          _react2.default.createElement(AnnotationShadow, null),
          _react2.default.createElement(AnnotationLine, null),
          _react2.default.createElement(
            MaybeLinkable,
            { linkTo: this.props.linkTo },
            _react2.default.createElement(FocusPoint, {
              hoverable: true,
              radius: '5',
              onAxis: this.props.onAxis,
              onMouseMove: this.handleMouseEnter,
              onMouseLeave: this.handleMouseLeave,
              onClick: this.handleClick
            })
          )
        ),
        this.state.isHovered && _react2.default.createElement(
          _TimestampTooltip2.default,
          {
            timestamp: this.props.timestamp,
            containerWidth: this.props.containerWidth,
            offsetY: this.props.containerHeight,
            offsetX: this.props.x
          },
          _react2.default.createElement(
            InfoLine,
            null,
            _react2.default.createElement(
              'strong',
              null,
              this.props.action
            )
          ),
          this.props.serviceIDs.map(function (serviceId) {
            return _react2.default.createElement(
              InfoLine,
              { key: serviceId },
              '\u2192 ',
              serviceId
            );
          })
        )
      );
    }
  }]);

  return DeploymentAnnotations;
}(_react2.default.PureComponent);

DeploymentAnnotations.propTypes = {
  x: _propTypes2.default.number.isRequired,
  action: _propTypes2.default.string.isRequired,
  serviceIDs: _propTypes2.default.array.isRequired,
  timestamp: _propTypes2.default.string.isRequired,
  containerWidth: _propTypes2.default.number.isRequired,
  containerHeight: _propTypes2.default.number.isRequired,
  onClick: _propTypes2.default.func.isRequired,
  linkTo: _propTypes2.default.string,
  onAxis: _propTypes2.default.bool
};

DeploymentAnnotations.defaultProps = {
  linkTo: '',
  onAxis: false
};

exports.default = DeploymentAnnotations;